begin;
CREATE TABLE rapport_advanced.listing_mail_message (
                                                       lm_id bigint GENERATED BY DEFAULT AS IDENTITY NOT NULL,
                                                       lm_subject text NOT NULL,
                                                       lm_message text NOT NULL,
                                                       listing_id bigint NULL,
                                                       CONSTRAINT listing_mail_message_pk PRIMARY KEY (lm_id),
                                                       CONSTRAINT listing_mail_message_listing_fk FOREIGN KEY (listing_id) REFERENCES rapport_advanced.listing(l_id) ON DELETE SET NULL ON UPDATE SET NULL
);
COMMENT ON TABLE rapport_advanced.listing_mail_message IS 'Previous message used in a listing when sending email';

-- Column comments

COMMENT ON COLUMN rapport_advanced.listing_mail_message.lm_subject IS 'Subject of the email';
COMMENT ON COLUMN rapport_advanced.listing_mail_message.lm_message IS 'Body of email';
COMMENT ON COLUMN rapport_advanced.listing_mail_message.listing_id IS 'FK to listing';
insert into rapport_advanced.version_listing values (2,now(),'Save previous email messages');
commit;