<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
require_once 'tva_constant.php';

use Belgian_Tax\Ext_Tva;
use Belgian_Tax\Ext_List_Assujetti;
use Belgian_Tax\Ext_List_Intra;

extract($_GET, EXTR_SKIP);
global $g_parameter, $cn;

$http = new \HttpInput();
$html = '';
$extra = '';
$ctl = '';
$act=$http->request("act");
switch ($act) {
    /**
     * display a saved form
     */
    case 'dsp_decl':
        /* the hide button */
        $button = new \IButton('hide');
        $button->label = _('Retour');
        $button->javascript = "$('detail').hide();$('main').show();";
        if ($type == 1) {
            /* display the declaration of amount */
            $decl = new Ext_Tva($cn);
            $decl->set_parameter('id', $id);
            $decl->load();
            $r = "";
            $r .= $decl->menu();
            $r .= $decl->display();
            $r .= $button->input();
        }
        if ($type == 3) {
            /* display the declaration for INTRACOM */
            $decl = new Ext_List_Intra($cn);
            $decl->set_parameter('id', $id);
            $decl->load();
            $r = "";
            $r .= $button->input();
            $r .= $decl->display();
            $r .= $button->input();
        }
        if ($type == 2) {
            /* display the declaration of customer */
            $decl = new Ext_List_Assujetti($cn);
            $decl->set_parameter('id', $id);
            $decl->load();
            $r = $button->input();
            $r .= $decl->display();
            $r .= $button->input();
        }

        break;
    /**
     * generate writing
     */
    case 'rw':
        $p_id = $http->request('p_id', 'number');
        $count = $cn->get_value('select count(*) from tva_belge.declaration_amount where da_id=$1', array($p_id));
        if ($count == 1) {
            $ctl = 'record_write';
            $ledger = new \Acc_ledger($cn, 0);
            $sel_ledger = $ledger->select_ledger('ODS', 1);
            $r = \HtmlInput::title_box('Génération écriture', 'record_write');
            if ($sel_ledger != null) {
                $r .= '<form id="vat_operation_form" onsubmit="save_write(this);return false;">';
                $decl = new Ext_Tva($cn);
                $decl->set_parameter('id', $p_id);
                $decl->load();
                $date = new \IDate('pdate');
                $r .= \HtmlInput::hidden("p_id", $p_id);
                $r .= "Date :" . $date->input() . '<br>';
                $r .= "Choix du journal : " . $sel_ledger->input();
                $r .= '<span class="text-muted">' . _("Opération pour purger la TVA") . '</span>';

                $r .= $decl->propose_form();
                $r .= \HtmlInput::hidden('mt', microtime(true));
                $r .= \HtmlInput::extension();
                $r .= \Dossier::hidden();
                $r .= '<ul class="aligned-block">';
                $r .= '<li>';
                $r .= \HtmlInput::submit('save', 'Sauver', 'onclick="return confirm(content[47])"');
                $r .= '</li>';
                $r .= '<li>';
                $r .= \HtmlInput::button_close("record_write");
                $r .= '</li>';
                $r .= '<li>';
                $r .= \HtmlInput::button(uniqid(), _("Actualise"), 'onclick="TVA_plugin.check_balance();return false;"');

                $r .= '</li>';
                $r .= '</ul>';
                $r .= '</form>';
            } else {
                $r .= '<h2 class="error">' . _("Aucun journal accessible") . '</h2>';
            }
        } else {
            $ctl = 'record_write';
            $r = \HtmlInput::title_box(_('Information'), $ctl);
            $r .= "<h2 class=\"info\">Désolé cette opération n'existe pas </h2>";
            $r .= '<p class="notice">Il se peut que l\'information a été effacée</p>';
            $r .= \HtmlInput::button_close($ctl);
        }
        break;
    /**
     * record in database the operation for purging VAT accounting
     */
    case 'sw':
        $ctl = 'record_write';
        $p_id = $http->request('p_id', 'number');
        $decl = new Ext_Tva($cn);
        $decl->set_parameter('id', $p_id);
        $decl->load();

        ob_start();
        echo \HtmlInput::title_box(_("Enregistrement"), "record_write");
        $http = new \HttpInput();
        $account = $http->get("account", 'array', []);
        $amount = $http->get("amount", 'array', []);
        $lib = $http->get("lib", 'array', []);

        try {
            $array = array();
            $array['p_currency_code'] = 0;
            $array['p_currency_rate'] = 1;
            $array['e_date'] = $pdate;
            /* give automatically the periode */
            $periode = new \Periode($cn);
            $periode->find_periode($pdate);
            $array['period'] = $periode->p_id;
            $idx = 0;
            $nb_item = 0;
            foreach ($account as $key => $value) {
                $i = $key;
                if (empty($account[$i])) continue;
                $array['amount' . $idx] = $amount[$i];
                $array['poste' . $idx] = $account[$i];
                $array['ld' . $idx] = $lib[$i];
                if (isset($deb[$i])) $array['ck' . $idx] = 1;
                $idx++;
                $nb_item++;
            }

            $array['nb_item'] = $nb_item;
            $array['e_pj'] = '';
            $array['e_pj_suggest'] = 'NONE';
            $array['jr_optype'] = 'NOR';
            $array['p_jrn'] = $p_jrn;
            $array['mt'] = $mt;

            $periodicy = array(1 => _("Mois"), 2 => _("Trimestre"));
            $array['desc'] = sprintf(_("Déclaration TVA %s %s  %s"), $decl->periode_dec, $periodicy[$decl->periodicity], $decl->exercice);
            $ods = new \Acc_Ledger($cn, $p_jrn);
            $ods->save($array);
            echo h2info("Sauvée : ajoutez le numéro de pièce");
            echo \HtmlInput::detail_op($ods->jr_id, 'détail opération : ' . $ods->internal);
            $ods->with_concerned = false;
            echo $ods->confirm($array, true);
            echo \HtmlInput::button_close("record_write");
        } catch (Exception $e) {
            echo alert($e->getMessage());
        }
        $r = ob_get_contents();
        ob_end_clean();
        break;
    case 'rm_form':
        switch ($type) {
            case 'da':
                $sql = "delete from tva_belge.declaration_amount where da_id=$1";
                break;
            case 'li':
                $sql = "delete from tva_belge.intracomm where i_id=$1";
                break;
            case 'lc':
                $sql = "delete from tva_belge.assujetti where a_id=$1";
                break;
        }
        $ctl = 'remove_form';
        $cn->exec_sql($sql, array($http->request('p_id')));
        $r = "";
        $r .= \HtmlInput::title_box(_("Information"), $ctl);
        $r .= '<h2 class="notice">' . _('Opération effacée') . '</h2>';
        $r .= \HtmlInput::button_close($ctl);
        $html = escape_xml($r);
        break;
    case 'add_param':
        // variable: $pcode string (GRIL..) id of the GRID
        $pcode = $http->get('pcode');

        // variable: $tab string tab of the form
        $tab = $http->get('tab');

        // variable: $pi_id number PK of table TVA_BELGE.PARAMETER_CHLD
        $pi_id = $http->get('pi_id');

        $ctl = "paramadd_id";
        $r = \HtmlInput::title_box("Ajout paramètre", $ctl);
        $r .= '<h3>' . _('Pour la grille ') . $pcode . '</h3>';
        $r .= '<form method="POST" id="faddparm" onsubmit="TVA_plugin.save();return false;" style="margin-left:15px">';
        $r .= \HtmlInput::request_to_hidden(array("tab", "gDossier", "plugin_code", "ac", "pcode"));
        $r .= \HtmlInput::hidden('act','save_addparam');
        try {
            $r .= \Belgian_Tax\Parameter\Tva_Parameter::input_form($pcode, $tab, $pi_id);
        } catch (\Exception $e) {
            $r .= $e->getMessage();
        }

        $r .= '<ul class="aligned-block">';
        $r .= '<li>';
        $r .= \HtmlInput::submit("save_addparam", "Sauver");
        $r .= '</li>';
        $r .= '<li>';
        $r .= \HtmlInput::button_close($ctl);
        $r .= '</li>';
        $r .= '</form>';
        $extra = $pi_id;
        break;
    case 'delete_param':
        /*
         * Remove a parameter from form
         */
        $r = "OK";
        $extra = "";
        try {
            $pi_id = $http->request("pi_id", "number");
            $cn->exec_sql("delete from tva_belge.parameter_chld where pi_id=$1", array($pi_id));
        } catch (Exception $e) {
            record_log(_('delete_param : echec'));
            record_log($e->getMessage());
            record_log($e->getTraceAsString());
            $r = "NOK";
            $extra = $e->getMessage();
        }
        break;
    case 'save_addparam':

        try {
            global $tab;

            // variable: $tva_id string VAT
            $tva_id = $http->post("tva_id", "string");

            // variable: $pi_id number PK of table TVA_BELGE.PARAMETER_CHLD , -1 for empty
            $pi_id = $http->post("pi_id", "number");

            // variable: $pcode string GRID
            $pcode=$http->post('pcode');

            // variable: $tab string selected tab (section)
            $tab=$http->post('tab');

            $plugin_code=$http->post('plugin_code');
            
            // var $filter_ledger number 1 for Purchase, 2 for Sale, 3
            //                        a ledger, 4 = Misc Operations Ledger
            // see tva_constant.php FILTER_LEDGER_*
            $filter_ledger = $http->post("filter_ledger", "number");
            if (    $filter_ledger != FILTER_LEDGER_FINANCIAL 
                    && $filter_ledger != FILTER_LEDGER_MISC
                ) 
            {
                $acc_tva = \Acc_Tva::build($cn, $tva_id);
                if ($acc_tva->tva_id == -1) throw new \Exception("TVA n'existe pas");
                $tva_id= $acc_tva->tva_id;
            }else {
                $tva_id=null;
            }

            $param_child_sql = new \Belgian_Tax\DB\Parameter_Chld_SQL($cn,$pi_id);
            $param_child_sql->setp('tva_id',$tva_id);
            $param_child_sql->setp('pcm_val', $http->post("paccount"));
            $param_child_sql->setp('pcode', $http->post('pcode'));
            $a = $http->post("ledger_id", "number");
            $ledger_id = ($filter_ledger != FILTER_LEDGER_ID) ? null : $a;
            $param_child_sql->setp('filter_ledger', $filter_ledger);
            $param_child_sql->setp('ledger_id', $ledger_id);
            $param_child_sql->setp('p_operation', $http->post("p_operation"));
            $param_child_sql->setp('p_side', $http->post("p_side", "string", "P"));
            $param_child_sql->save();

            $a_code=$cn->get_row(\Belgian_Tax\Parameter\Tva_Parameter::SQL_DETAIL_ROW.
    "			where pi_id=$1 ",[$param_child_sql->pi_id]);
            $r=\Belgian_Tax\Parameter\Tva_Parameter::print_row($pcode,$plugin_code,$a_code);
            $ctl=$param_child_sql->pi_id;
        } catch (\Exception $e) {
            $r=("Ne peut sauver : " . $e->getMessage());
        }
        break;
    default:
        $r = var_export($_REQUEST, true);
}

$html = escape_xml($r);

header('Content-type: text/xml; charset=UTF-8');
echo <<<EOF
<?xml version="1.0" encoding="UTF-8"?>
<data>
<ctl>$ctl</ctl>
<code>$html</code>
<extra>$extra</extra>
</data>
EOF;
?>
