<?php
namespace Belgian_Tax\DB;
/**
 *   This file is part of NOALYSS
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * copyright Dany WM De Bontridder(2024)
 *
 *  Dec 2024
 */

/**
 * @file
 * @brief ORM Table TVA_BELGE.PARAMETER_CHLD
 */

/**
 * @class Parameter_Chld_SQL
 *
 * @brief ORM Table TVA_BELGE.PARAMETER_CHLD
 */
class Parameter_Chld_SQL extends \Table_Data_SQL
{

    function __construct(\DatabaseCore $p_cn, $p_id = -1)
    {
        $this->table = "tva_belge.parameter_chld";
        $this->primary_key = "pi_id";
        /*
         * List of columns
         */
        $this->name = array(
            "pi_id" => "pi_id",
            'pcode' => 'pcode',
            'tva_id' => 'tva_id',
            'pcm_val' => 'pcm_val',
            'ledger_id' => 'ledger_id',
            "filter_ledger" => "filter_ledger",
            "p_operation" => "p_operation",
            "p_side" => "p_side"

        );
        /*
         * Type of columns
         */
        $this->type = array(
            "pi_id" => "numeric",
            'pcode' => 'text',
            'tva_id' => 'numeric',
            'pcm_val' => 'text',
            'ledger_id' => 'numeric',
            "filter_ledger" => "numeric",
            "p_operation" => "char",
            "p_side"=>"char"
        );


        $this->default = array(
            "pi_id" => "auto"
        );

        parent::__construct($p_cn, $p_id);
    }


}