<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 9/12/24
/*! 
 * \file
 * \brief display the detail of the computed amount
 */

if (!defined('ALLOWED')) {
    die ("not allowed");
}

/**
 * @var $aPcode array of PCODE found in TVA_BELGE.DECLARATION_AMOUNT_DETAIL
 * @var $this \Belgian_Tax\Ext_Tva
 */

$nb_pcode = count($aPcode);
if ($nb_pcode == 0) {
    return;
}

$operation=['A'=>_('Addition'),'S'=>_('Soustrait')];
$side=['P'=>'','N'=>_('négatif')];

for ($i = 0; $i < $nb_pcode; $i++) :
    ?>
    <div id="<?= $aPcode[$i]['pcode'] ?>" class="inner_box2" style="display:none">
        <?php
            echo \HtmlInput::title_box($aPcode[$i]['pcode'], $aPcode[$i]['pcode'],'hide');
            $result=$this->db->get_array('select t2.tva_id
,t2.tva_code 
,pcm_val
,ledger_id
,filter_ledger
,p_operation
,p_side 
,d1_amount
,jrn_def_name
,d1_info
from TVA_BELGE.DECLARATION_AMOUNT_DETAIL d1
join tva_belge.parameter_chld pc on (pc.pi_id=parameter_child_id)
left join tva_rate t2 on pc.tva_id=t2.tva_id
left join jrn_def j1 on (j1.jrn_def_id =pc.ledger_id)
where detail_id=$2 and pcode=$1',[$aPcode[$i]['pcode'],$this->detail_id]);
            $nb_result=count($result);
            ?>
        <div class="row">
            <div class="col highlight text-center"><?=_('Code TVA')?></div>
            <div class="col highlight text-center"><?=_("Poste comptable")?></div>
            <div class="col highlight text-center"><?=_('Journal')?></div>
            <div class="col highlight text-center"><?=_('Operation')?></div>
            <div class="col highlight text-center"><?=_('Signe')?></div>
            <div class="col highlight text-right"><?=_('Montant')?></div>
            <div class="col highlight text-center"><?=_('Info')?></div>
        </div>
<?php
            for ($e=0;$e < $nb_result;$e++) :
            $odd=($e%2==0)?'odd':'';    ?>
            <div class="row <?=$odd?>">
                <div class="col text-center">
                    <?=$result[$e]['tva_id']?> /
                    <?=$result[$e]['tva_code']?>
                </div>
                <div class="col text-center">
                    <?=$result[$e]['pcm_val']?>
                </div>
                <div class="col text-center">
                    <?php
                    switch ($result[$e]['filter_ledger']) {
                        case FILTER_LEDGER_SALE:
                            echo _('Journaux VENTE');
                            break;
                        case FILTER_LEDGER_PURCHASE:
                            echo _('Journaux ACHAT');
                            break;
                        case FILTER_LEDGER_FINANCIAL:
                            echo _("Journaux financiers");
                            break;
                        case FILTER_LEDGER_MISC:
                            echo _("Journaux opérations diverses");
                            break;
                        case FILTER_LEDGER_ID:
                            echo  $result[$e]['jrn_def_name'];
                            break;
                    }

                    ?>
                </div>
                <div class="col text-center">
                    <?=$operation [ $result[$e]['p_operation']]?>
                </div>
                <div class="col text-center">
                    <?=$side [ $result[$e]['p_side']]?>
                </div>
                <div class="col text-right">
                    <?=nbm($result[$e]['d1_amount'])?>
                </div>
                <div class="col" class="bg-warning">
                    <?=$result[$e]['d1_info']?>
                </div>
            </div>
            <?php
                endfor;


        ?>
<ul class="aligned-block">
    <li>
        <?=\HtmlInput::button_hide($aPcode[$i]['pcode'])?>
    </li>
</ul>
    </div>
<?php
endfor;